type 'a t = {mutable taille : int; mutable elements : 'a array}

let length t = t.taille

let add elt t =
  let taille = t.taille in
  if taille < Array.length t.elements
  then (t.elements.(taille) <- elt)
  else (* il faut redimensionner [elements] *)
    (assert (taille = Array.length t.elements);
     let new_elements = Array.make (max 1 (2*taille)) elt in
     Array.blit t.elements 0 new_elements 0 taille;
     t.elements <- new_elements);
  t.taille <- succ taille

let take_constant_size t =
  assert (t.taille > 0);
  t.taille <- pred t.taille;
  t.elements.(t.taille)

let take t =
  let result = take_constant_size t in
  let half_length = Array.length t.elements /2 in
  if t.taille < half_length
  then t.elements <- Array.sub t.elements 0 half_length;
  result

let unsafe_get t = Array.get t.elements
let unsafe_set t = Array.set t.elements

let get t index =
  assert (0 <= index && index < t.taille);
  unsafe_get t index

let set t index =
  assert (0 <= index && index < t.taille);
  unsafe_set t index

let make length elt = {taille = length; elements = Array.make length elt}
let iter f t =
  for i=0 to pred t.taille do f t.elements.(i) done
let of_array array = {taille = Array.length array; elements = Array.copy array}
